/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;		AVR t861 TestProgramm
;
;
;		CPU	ATtiny861A-PU
;			CLK=INT CRosc(8MHz)
;			FuseE="01" FuseH="DF" FuseL="E2" 
;
;			
;		2012-06-19		c[H[Ec
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/


#include <avr/io.h>


volatile static unsigned int	TIME;

volatile static unsigned char	HEXH,HEXL;



void Bit_timer(void){

	volatile int i;

	for(i=0; i<47; i++){			//9600BPS
	}
}



void TX(unsigned char TXD){

	volatile int i;

	PORTA &= 0xfe;					//1 StartBit 
	Bit_timer();
	for(i=0; i<8; i++){				//8 DataBit
		PORTA = (PORTA & 0xfe) | (TXD & 0x01);
		Bit_timer();
		TXD = TXD >> 1;
	}
	PORTA |= 0x01;					//2 StopBit
	Bit_timer();
	Bit_timer();
}



void Wait(void){					/* 1mS Timer */
	volatile int i;

	for(i=0; i<464; i++){
	}

}



void Timer(int Time){			/* mS Timer */
	volatile int i;

	for(i=0; i<Time; i++){
		Wait();
	}

}



unsigned char hex(unsigned char bin){

	bin &= 0x0f;					//O`PT
	if (bin < 10){
		bin = bin | 0x30;
	}
	else{
		bin = bin + 0x37;
	}

	return bin;
}



void bin_hex(unsigned char bin){	//Binary  2Hex(HEXH,HEXL)

	unsigned char hi,lo;

	hi = bin / 16;
	HEXH = hex(hi);
	lo = bin % 16;
	HEXL = hex(lo);
}



void TX_int(unsigned int DATA){
		bin_hex(DATA / 256);
		TX(HEXH);
		TX(HEXL);
		bin_hex(DATA & 0x00ff);
		TX(HEXH);
		TX(HEXL);
		TX(0x20);
}






void Init(void){			/*Initialize*/

	DDRA = 0xff;			//portA output
	PORTA = 0x01;
	DDRB = 0xff;			//portB output
	PORTB = 0x00;


	Timer(50);

	TIME = 0;

}



int main(){

	volatile int i;


	Init();

while(1){


	for(i=0; i<3; i++){

		Timer(2000);
		PORTA = 0xff;
		PORTB = 0xff;

		Timer(1000);
		PORTA = 0x01;
		PORTB = 0x00;

	}



	for(i=0; i<15; i++){

		Timer(200);
		PORTA = 0x55;
		PORTB = 0x55;

		Timer(200);
		PORTA = 0xab;
		PORTB = 0xaa;

		TX_int(i);

	}

}


}
